Bundle Transformer - a modular extension for the [System.Web.Optimization](https://github.com/aspnet/AspNetWebOptimization) (also known as the Microsoft ASP.NET Web Optimization Framework).
`StyleTransformer` and `ScriptTransformer` classes, included in the core of Bundle Transformer and implement the `IBundleTransform` interface.
They are intended to replace the standard classes: `CssMinify` and `JsMinify`.

The main differences of the `StyleTransformer` and `ScriptTransformer` classes from a standard implementations: ability to exclude unnecessary assets when adding assets from a directory, does not produce the re-minification of pre-minified assets, support automatic transformation of relative paths to absolute in CSS code (by using the `UrlRewritingCssPostProcessor`), etc.
These classes do not produce the minification of code in runtime, but this feature can be added by installing of minifier-modules (now available modules based on [Microsoft Ajax Minifier](https://github.com/microsoft/ajaxmin), [YUI Compressor for .NET](https://github.com/YUICompressor-NET/YUICompressor.NET), [NUglify](https://github.com/trullock/NUglify), [Google Closure Compiler](https://developers.google.com/closure/compiler/), Douglas Crockford's [JSMin](https://github.com/douglascrockford/JSMin), Dean Edwards' [Packer](http://dean.edwards.name/packer/), Mihai Bazon's [UglifyJS](https://github.com/mishoo/UglifyJS), Sergey Kryzhanovsky's [CSSO](https://github.com/css/csso) (CSS Optimizer), [WebGrease](https://www.nuget.org/packages/WebGrease) and [Clean-css](https://github.com/clean-css/clean-css)).
In addition, you can also install translator-modules, that implement the translation of code on intermediate languages ([LESS](https://lesscss.org/), [Sass](https://sass-lang.com/), [SCSS](https://sass-lang.com/), [CoffeeScript](https://coffeescript.org/), [TypeScript](https://www.typescriptlang.org/), [Mustache](https://mustache.github.io/) (by using [Hogan](https://twitter.github.io/hogan.js/)) and [Handlebars](https://handlebarsjs.com/)).
Apart from this, in the Bundle Transformer there is a third type of modules - postprocessors. Postprocessors runs after translators and before minifiers.
Now available following postprocessors: URL rewriting CSS postprocessor (included in core) and postprocessor-module based on the Andrey Sitnik's [Autoprefixer](https://github.com/postcss/autoprefixer).

This extension will help your web applications successfully pass a most part of the tests in [Google PageSpeed](https://pagespeed.web.dev/).